/*
 * Copyright (c) 2016 Scott Wells, All rights reserved
 */

// Stub interfaces for the JavaScript Aura API taken from:
// http://documentation.auraframework.org/auradocs

/**
@type {$A}
@const
*/
$A = {};
$A.prototype = {
    // Properties
    localizationService: null,
    util: null,

    // Methods
    createComponent: function(type, attributes, callback) {},
    createComponents: function(components, callback) {},
    enqueueAction: function(action, background) {},
    error: function(message, err) {},
    get: function(key, callback) {},
    getCallback: function(callback) {},
    getComponent: function(identifier) {},
    getRoot: function() {},
    log: function(value, error) {},
    newCmp: function(config, attributeValueProvider) {},
    newCmpAsync: function(callbackScope, callback, config, attributeValueProvider, localCreation, doForce, forceServer) {},
    reportError: function(message, error) {},
    run: function(func, name) {},
    set: function(key, value) {},
    warning: function(message, err) {}
};

/**
@type {Action}
@const
*/
Action = {};
Action.prototype = {
    // Methods
    copyToRefresh: function() {},
    getAbortableId: function() {},
    getDef: function() {},
    getError: function() {},
    getParam: function(name) {},
    getParams: function() {},
    getReturnValue: function() {},
    getState: function() {},
    getStorage: function() {},
    getStorageErrorHandler: function() {},
    getStorageKey: function() {},
    isAbortable: function() {},
    isBackground: function() {},
    isCaboose: function(name) {},
    isExclusive: function() {},
    isFromStorage: function() {},
    isRefreshAction: function() {},
    isStorable: function() {},
    markException: function(e) {},
    run: function(event) {},
    runAfter: function(action) {},
    runDeprecated: function(event) {},
    setAbortable: function() {},
    setAllAboardCallback: function(scope, callback) {},
    setBackground: function() {},
    setCaboose: function() {},
    setCallback: function(scope, callback, name) {},
    setChained: function() {},
    setExclusive: function() {},
    setParam: function(key, value) {},
    setParams: function(config) {},
    setStorable: function(config) {},
    toJSON: function() {}
};

/**
@type {ActionDef}
@const
*/
ActionDef = {};
ActionDef.prototype = {
    // Methods
    getName: function() {},
    isClientAction: function() {},
    isServerAction: function() {},
    toString: function() {}
};

/**
@type {AttributeDef}
@const
*/
AttributeDef = {};
AttributeDef.prototype = {
    // Methods
    getDefault: function() {},
    getDescriptor: function() {},
    getNativeType: function() {},
    isRequired: function() {}
};

/**
@type {AttributeDefSet}
@const
*/
AttributeDefSet = {};
AttributeDefSet.prototype = {
    // Methods
    each: function(func) {},
    getDef: function(name) {},
    getNames: function() {},
    getValues: function() {}
};

/**
@type {AttributeSet}
@const
*/
AttributeSet = {};
AttributeSet.prototype = {
    // Methods
    getShadowValue: function() {},
    isTypeOfArray: function() {},
    isValueValidForAttribute: function() {},
    setShadowValue: function() {}
};

/**
@type {AuraClientService}
@const
*/
AuraClientService = {};
AuraClientService.prototype = {
    // Methods
    addComponentHandlers: function(component, actionEventHandlers) {},
    allowAccess: function() {},
    buildStorableServerAction: function() {},
    collectServerAction: function() {},
    continueClientActions: function(name) {},
    continueCompletions: function() {},
    continueProcessing: function() {},
    countAvailableXHRs: function() {},
    createIntegrationErrorConfig: function(errorText) {},
    deDupe: function(action, sending) {},
    decode: function(response, noStrip, timedOut) {},
    deferAction: function(action) {},
    deferPendingActions: function() {},
    dumpCachesAndReload: function(name) {},
    enqueueAction: function(action, background) {},
    enqueueStoredAction: function() {},
    executeClientAction: function() {},
    executeStoredAction: function() {},
    finishCollection: function(e) {},
    finishProcessing: function() {},
    fireDoneWaiting: function() {},
    getAndClearDupes: function() {},
    getAvailableXHR: function(isBackground) {},
    getManifestURL: function() {},
    getStoredResult: function() {},
    getUseBootstrapCache: function() {},
    handleAppCache: function() {},
    hardRefresh: function() {},
    hasActionStorage: function() {},
    inFlightXHRs: function() {},
    init: function(config, token, callback, container) {},
    initDefs: function(config) {},
    initHost: function(host) {},
    injectComponent: function(rawConfig, locatorDomId, localId) {},
    injectComponentAsync: function(config, locator, eventHandlers, callback) {},
    invalidSession: function() {},
    invalidateAction: function(descriptor, params, successCallback, errorCallback) {},
    isActionInStorage: function(descriptor, params, callback) {},
    isBB10: function() {},
    isConnected: function() {},
    isDevMode: function() {},
    isDisconnectedOrCancelled: function() {},
    isInternalNamespace: function() {},
    isManifestPresent: function() {},
    isPrivilegedNamespace: function() {},
    loadTokenFromStorage: function() {},
    parseAndFireEvent: function() {},
    populatePersistedActionsFilter: function() {},
    postProcess: function() {},
    process: function() {},
    processIncompletes: function() {},
    processResponses: function() {},
    processXHRIdleQueue: function() {},
    releaseXHR: function() {},
    renderInjection: function(component, locator, actionEventHandlers) {},
    resetToken: function(newToken) {},
    revalidateAction: function(descriptor, params, callback) {},
    runActions: function(actions, scope, callback) {},
    runClientActions: function() {},
    runWhenXHRIdle: function(func) {},
    saveTokenToStorage: function() {},
    send: function(auraXHR, actions, method, options) {},
    sendActionXHRs: function() {},
    setConnected: function(isConnected) {},
    setOutdated: function() {},
    setUseBootstrapCache: function(useBootstrapCache) {},
    setXHRTimeout: function(timeout) {},
    setupPersistedActionsFilter: function() {}
};

/**
@type {AuraComponentContext}
@const
*/
AuraComponentContext = {};
AuraComponentContext.prototype = {
    // Properties
    stack: null,

    // Methods
    Frame: function() {},
    addNote: function() {},
    clearNote: function() {},
    currentContext: function() {},
    getNote: function() {},
    pop: function(component) {},
    push: function(component) {}
};

/**
@type {AuraComponentService}
@const
*/
AuraComponentService = {};
AuraComponentService.prototype = {
    // Methods
    addComponentClass: function(descriptor, exporter) {},
    addLibraryInclude: function(descriptor, dependencies, exporter) {},
    buildDependencyGraph: function() {},
    clearDefsFromStorage: function(metricsPayload) {},
    computeValue: function(valueObj, valueProvider) {},
    countComponents: function() {},
    createComponent: function(type, attributes, callback) {},
    createComponentFromConfig: function(config) {},
    createComponentInstance: function(config, localCreation) {},
    createComponentPriv: function() {},
    createComponentPrivAsync: function() {},
    createComponents: function(components, callback) {},
    createInternalConfig: function() {},
    evictDefsFromStorage: function(sortedKeys, graph, requiredSpaceKb) {},
    findDependencies: function(key, defConfig, storedDeps) {},
    get: function(globalId) {},
    getAttributeProviderForElement: function(element) {},
    getComponent: function(identifier) {},
    getComponentClass: function(descriptor) {},
    getComponentConfigs: function(config, attributeValueProvider) {},
    getDef: function(descriptor) {},
    getDynamicNamespaces: function() {},
    getIndex: function() {},
    getRegisteredComponentDescriptors: function() {},
    getRenderingComponentForElement: function(element) {},
    getUnusedDefinitions: function() {},
    getUpstreamDependencies: function(rootKey, graph, upstream) {},
    hasComponentClass: function(descriptor) {},
    hasDefinition: function() {},
    hasLibrary: function(descriptor) {},
    newComponent: function(config, attributeValueProvider) {},
    newComponentAsync: function(callbackScope, callback, config, attributeValueProvider, localCreation, doForce, forceServer) {},
    newComponentDeprecated: function(config, attributeValueProvider) {},
    pruneDefsFromStorage: function(requiredSpaceKb) {},
    restoreDefsFromStorage: function() {},
    saveComponentConfig: function(config) {},
    saveDefsToStorage: function(config, context) {},
    saveLibraryConfig: function(config) {},
    sortDependencyGraph: function(graph) {},
    splitComponentsAndActions: function(graph, keys, exclude, actions, defs) {}
};

/**
@type {AuraContext}
@const
*/
AuraContext = {};
AuraContext.prototype = {
    // Properties
    CLIENT_SESSION_ID: null,

    // Methods
    clearComponentConfigs: function(actionId) {},
    getAccessVersion: function() {},
    getApp: function() {},
    getCurrentAccessCaller: function() {},
    getCurrentAction: function() {},
    getLoaded: function() {},
    getMode: function() {},
    initGlobalValueProviders: function() {},
    merge: function(otherContext) {},
    releaseCurrentAccess: function() {},
    resetLoaded: function() {},
    setContextPath: function() {},
    setCurrentAccess: function() {},
    setCurrentAction: function() {}
};

/**
@type {AuraContextPlugin}
@const
*/
AuraContextPlugin = {};
AuraContextPlugin.prototype = {
    // Methods
    bind: function() {},
    disable: function() {},
    enable: function() {},
    initialize: function() {},
    postProcess: function() {},
    unbind: function() {}
};

/**
@type {AuraError}
@const
*/
AuraError = {};
AuraError.prototype = {
    // Methods
    toString: function() {}
};

/**
@type {AuraEventService}
@const
*/
AuraEventService = {};
AuraEventService.prototype = {
    // Methods
    addHandler: function(config) {},
    createFromSavedConfigs: function(config) {},
    get: function(name, callback) {},
    getDef: function(descriptor) {},
    getNewEvent: function(eventDef, eventName, sourceComponent) {},
    getRegisteredEvents: function() {},
    hashHandlers: function(name) {},
    hasPendingEvents: function() {},
    newEvent: function(eventDef, eventName, sourceComponent) {},
    qualifyEventName: function(event) {},
    removeHandler: function(config) {},
    saveEventConfig: function(config) {}
};

/**
@type {AuraExpressionService}
@const
*/
AuraExpressionService = {};
AuraExpressionService.prototype = {
    // Methods
    addListener: function() {},
    clearReferences: function() {},
    create: function() {},
    createPassthroughValue: function() {},
    getReference: function() {},
    normalize: function(expression) {},
    removeListener: function() {},
    resolve: function(expression, container, rawValue) {},
    updateGlobalReference: function() {},
    updateGlobalReferences: function() {}
};

/**
@type {AuraFriendlyError}
@const
*/
AuraFriendlyError = {};
AuraFriendlyError.prototype = {
    // Methods
    toString: function() {}
};

/**
@type {AuraHistoryService}
@const
*/
AuraHistoryService = {};
AuraHistoryService.prototype = {
    // Methods
    back: function() {},
    forward: function() {},
    get: function() {},
    replace: function(token) {},
    reset: function() {},
    set: function(token) {},
    setTitle: function(title) {}
};

/**
@type {AuraInstance}
@const
*/
AuraInstance = {};
AuraInstance.prototype = {
    // Properties
    client: null,
    cmp: null,
    e: null,
    history: null,
    l10n: null,
    localization: null,
    localizationService: null,
    locker: null,
    metrics: null,
    services: null,
    severity: null,
    storage: null,
    style: null,
    util: null,

    // Methods
    addValueProvider: function(type, valueProvider) {},
    assert: function(condition, assertMessage) {},
    error: function(message, error) {},
    get: function(key, callback) {},
    getCallback: function(callback) {},
    getContext: function() {},
    getCurrentTransactionId: function() {},
    getDefinition: function(descriptor, callback) {},
    getDefinitions: function(descriptors, callback) {},
    getReference: function(key) {},
    getRoot: function() {},
    getToken: function(token) {},
    hasDefinition: function(descriptor) {},
    initAsync: function(config) {},
    initConfig: function(config, useExisting, doNotInitializeServices) {},
    installOverride: function(name, func, scope, priority) {},
    log: function(value, error) {},
    message: function(message) {},
    popCreationPath: function(creationPath) {},
    pushCreationPath: function(creationPath) {},
    reportError: function(message, error) {},
    run: function(func, name) {},
    set: function(key, value) {},
    setCreationPathIndex: function(creationPath) {},
    setCurrentTransactionId: function() {},
    setLanguage: function() {},
    trace: function() {},
    uninstallOverride: function() {},
    userAssert: function(condition, message) {},
    warning: function(message, error) {}
};

/**
@type {AuraLocalizationService}
@const
*/
AuraLocalizationService = {};
AuraLocalizationService.prototype = {
    // Methods
    UTCToWallTime: function(date, timezone, callback) {},
    WallTimeToUTC: function(date, timezone, callback) {},
    displayDuration: function(duration, noSuffix) {},
    displayDurationInDays: function(duration) {},
    displayDurationInHours: function(duration) {},
    displayDurationInMilliseconds: function(duration) {},
    displayDurationInMinutes: function(duration) {},
    displayDurationInMonths: function(duration) {},
    displayDurationInSeconds: function(duration) {},
    duration: function(number, unit) {},
    endOf: function(date, unit) {},
    formatCurrency: function(number) {},
    formatDate: function(date, formatString, locale) {},
    formatDateTime: function(date, formatString, locale) {},
    formatDateTimeUTC: function(date, formatString, locale) {},
    formatDateUTC: function(date, formatString, locale) {},
    formatNumber: function(number) {},
    formatPercent: function(number) {},
    formatTime: function(date, formatString, locale) {},
    formatTimeUTC: function(date, formatString, locale) {},
    getDateStringBasedOnTimezone: function(timezone, date, callback) {},
    getDaysInDuration: function(duration) {},
    getDefaultCurrencyFormat: function() {},
    getDefaultNumberFormat: function() {},
    getDefaultPercentFormat: function() {},
    getHoursInDuration: function(duration) {},
    getLocalizedDateTimeLabels: function() {},
    getMillisecondsInDuration: function(duration) {},
    getMonthsInDuration: function(duration) {},
    getNumberFormat: function(format, symbols) {},
    getSecondsInDuration: function(duration) {},
    getSecondsInDuration: function(duration) {},
    getToday: function(timezone, callback) {},
    getYearsInDuration: function(duration) {},
    isAfter: function(date1, date2, unit) {},
    isBefore: function(date1, date2, unit) {},
    isPeriodTimeView: function(dateTime) {},
    isSame: function(date1, date2, unit) {},
    parseDateTime: function(dateTimeString, targetFormat, locale, strict) {},
    parseDateTimeISO8601: function(dateTimeString) {},
    parseDateTimeUTC: function(dateTimeString, targetFormat, locale, strict) {},
    startOf: function(date, unit) {},
    toISOString: function(date) {},
    translateFromLocalizedDigits: function(input) {},
    translateFromOtherCalendar: function(date) {},
    translateToLocalizedDigits: function(input) {},
    translateToOtherCalendar: function(date) {}
};

/**
@type {AuraRenderingService}
@const
*/
AuraRenderingService = {};
AuraRenderingService.prototype = {
    // Methods
    addAuraClass: function() {},
    afterRender: function(components) {},
    cleanComponent: function() {},
    createMarker: function() {},
    finishRender: function() {},
    getMarker: function(component) {},
    isMarker: function() {},
    render: function(components, parent) {},
    renderFacet: function(component, facet, parent) {},
    rerender: function(components) {},
    rerenderFacet: function(component, facet, referenceNode) {},
    unrender: function(components) {},
    unrenderFacet: function(component, facet) {}
};

/**
@type {AuraStorage}
@const
*/
AuraStorage = {};
AuraStorage.prototype = {
    // Properties
    SWEEP_INTERVAL: 0,

    // Methods
    clear: function() {},
    get: function(key) {},
    getAll: function() {},
    getDefaultAutoRefreshInterval: function() {},
    getSize: function() {},
    getVersion: function() {},
    inFlightOperations: function() {},
    isPersistent: function() {},
    isSecure: function() {},
    put: function(key, value) {},
    resumeSweeping: function() {},
    setVersion: function(version) {},
    suspendSweeping: function() {}
};

/**
@type {AuraStorageService}
@const
*/
AuraStorageService = {};
AuraStorageService.prototype = {
    // Methods
    createAdapter: function(adapter, name, maxSize, debugLoggingEnabled, expiration) {},
    deleteStorage: function(name) {},
    fireModified: function() {},
    getAdapterConfig: function(adapter) {},
    getStorage: function(name) {},
    getStorages: function() {},
    getVersion: function() {},
    initStorage: function(name, persistent, secure, maxSize, defaultExpiration, defaultAutoRefreshInterval, debugLoggingEnabled, clearStorageOnInit, version) {},
    isRegisteredAdapter: function(name) {},
    registerAdapter: function(config) {},
    selectAdapter: function(persistent, secure) {},
    setIsolation: function(isolationKey) {},
    setVersion: function(version) {}
};

/**
@type {AuraStyleService}
@const
*/
AuraStyleService = {};
AuraStyleService.prototype = {
    // Methods
    applyAllTokens: function(descriptors, config, replaceExisting, extraStyles, storable, callback, customHandler, forceClientScan) {},
    applyTokens: function(descriptor, config, replaceExisting, extraStyles, storable, callback, customHandler, forceClientScan) {},
    removeTokens: function() {}
};

/**
@type {BitSet}
@const
*/
BitSet = {};
BitSet.prototype = {
    // Methods
    clearBit: function() {},
    init: function() {},
    length: function() {},
    pad: function() {},
    setBit: function() {},
    testBit: function() {},
    toString: function() {},
    trim: function() {}
};

/**
@type {Component}
@const
*/
Component = {};
Component.prototype = {
    // Methods
    addDocumentLevelHandler: function(eventName, callback, autoEnable) {},
    addHandler: function(eventName, valueProvider, actionExpression, insert) {},
    addValueHandler: function(config) {},
    addValueProvider: function(key, valueProvider) {},
    afterRender: function() {},
    associateRenderedBy: function() {},
    autoDestroy: function(destroy) {},
    clearReference: function(key) {},
    createActionValueProvider: function() {},
    createComponentStack: function() {},
    createStyleValueProvider: function() {},
    destroy: function(async) {},
    doDeIndex: function() {},
    doIndex: function() {},
    find: function(name) {},
    finishDestroy: function() {},
    fireChangeEvent: function() {},
    get: function(key) {},
    getActionCaller: function() {},
    getAttributeValueProvider: function() {},
    getComponentValueProvider: function() {},
    getConcreteComponent: function() {},
    getDef: function() {},
    getElement: function() {},
    getElements: function(duration) {},
    getEvent: function(name) {},
    getEventDispatcher: function() {},
    getFacets: function() {},
    getFlavor: function() {},
    getGlobalId: function() {},
    getHandledEvents: function() {},
    getHandler: function() {},
    getLocalId: function() {},
    getMethodHandler: function() {},
    getModel: function() {},
    getName: function() {},
    getReference: function(key) {},
    getRendering: function() {},
    getValueProvider: function() {},
    getVersion: function() {},
    hasEventHandler: function(eventName) {},
    injectComponent: function() {},
    isConcrete: function() {},
    isDirty: function() {},
    isFlavorable: function() {},
    isInstanceOf: function(name) {},
    isValid: function() {},
    markClean: function() {},
    markDirty: function() {},
    nextGlobalId: function() {},
    provide: function(localCreation) {},
    removeDocumentLevelHandler: function(handler) {},
    removeValueHandler: function() {},
    removeValueProvider: function(key) {},
    render: function() {},
    replaceComponentClass: function() {},
    rerender: function() {},
    set: function(key, value) {},
    setAttributeValueProvider: function() {},
    setProvided: function() {},
    setSuperComponent: function() {},
    setupApplicationEventHandlers: function() {},
    setupAttributes: function() {},
    setupComponentDef: function() {},
    setupComponentEvents: function() {},
    setupFlavors: function() {},
    setupGlobalId: function() {},
    setupMethods: function() {},
    setupModel: function() {},
    setupSuper: function() {},
    setupValueEventHandlers: function() {},
    setupValueProviders: function() {},
    toString: function() {},
    unrender: function() {},
    validatePartialConfig: function() {}
};

/**
@type {ComponentClassRegistry}
@const
*/
ComponentClassRegistry = {};
ComponentClassRegistry.prototype = {
    // Methods
    addComponentClass: function(descriptor, exporter) {},
    buildComponentClass: function(componentProperties) {},
    buildConstructor: function(componentProperties) {},
    buildInheritance: function(componentProperties) {},
    buildLibraries: function(componentProperties) {},
    getComponentClass: function(descriptor) {},
    hasComponentClass: function(descriptor) {}
};

/**
@type {ComponentDef}
@const
*/
ComponentDef = {};
ComponentDef.prototype = {
    // Properties
    valueEvents: null,

    // Methods
    getAllEvents: function() {},
    getAllFlavoredStyleDefs: function() {},
    getAllStyleDefs: function() {},
    getAppHandlerDefaults: function() {},
    getAttributeDefs: function() {},
    getCmpHandlersDefs: function() {},
    getControllerDef: function() {},
    getDefaultFlavor: function() {},
    getDescriptor: function() {},
    getEventDef: function(eventDefName, includeValueEvents) {},
    getExplicitDefaultFlavor: function() {},
    getFacets: function() {},
    getFlavorOverrides: function() {},
    getHelper: function() {},
    getLayouts: function() {},
    getLocationChangeEvent: function() {},
    getModelDef: function() {},
    getRequiredVersionDefs: function() {},
    getStyleClassName: function() {},
    getStyleDef: function() {},
    getSuperDef: function() {},
    getValueHandlerDefs: function() {},
    hasFlavorableChild: function() {},
    hasRemoteDependencies: function() {},
    isAbstract: function() {},
    isInstanceOf: function(name) {},
    toString: function() {}
};

/**
@type {ComponentDefStorage}
@const
*/
ComponentDefStorage = {};
ComponentDefStorage.prototype = {
    // Properties
    EVICTION_HEADROOM: null,
    EVICTION_TARGET_LOAD: null,
    MUTEX_KEY: null,
    TRANSACTION_SENTINEL_KEY: null,
    mutexUnlock: null,
    queue: null,

    // Methods
    clear: function(metricsPayload) {},
    enqueue: function(execute) {},
    getAll: function() {},
    getStorage: function() {},
    removeDefs: function(descriptors) {},
    restoreAll: function() {},
    setupDefinitionStorage: function() {},
    storeDefs: function(componentConfigs, libConfigs) {},
    useDefinitionStorage: function() {}
};

/**
@type {ComponentServiceMetricsPlugin}
@const
*/
ComponentServiceMetricsPlugin = {};
ComponentServiceMetricsPlugin.prototype = {
    // Methods
    bind: function() {},
    createComponentsOverride: function() {},
    disable: function() {},
    enabled: function() {},
    initialize: function() {},
    postProcess: function() {},
    unbind: function() {}
};

/**
@type {ContextValueProvider}
@const
*/
ContextValueProvider = {};
ContextValueProvider.prototype = {
    // Methods
    get: function(key) {},
    serializeForServer: function() {},
    set: function(key, value) {}
};

/**
@type {ControllerDef}
@const
*/
ControllerDef = {};
ControllerDef.prototype = {
    // Methods
    get: function(key) {},
    getActionDef: function(key) {},
    getDescriptor: function() {}
};

/**
@type {CryptoAdapter}
@const
*/
CryptoAdapter = {};
CryptoAdapter.prototype = {
    // Properties
    ALGO: null,
    IV_LENGTH: null,
    LOG_LEVEL: null,
    NAME: null,
    SENTINEL: null,
    engine: null,
    key: null,

    // Methods
    register: function() {},
    setKey: function(rawKey) {},
    clear: function() {},
    clearOnInit: function() {},
    deleteStorage: function() {},
    fallbackToMemoryAdapter: function() {},
    getAll: function() {},
    getItem: function(key) {},
    getName: function() {},
    getSize: function() {},
    isCrypto: function() {},
    isPersistent: function() {},
    isSecure: function() {},
    remoteItem: function(key) {},
    removeItemInternal: function(key, resolve, reject) {},
    resumeSweeping: function() {},
    setItem: function(key, item, size) {},
    setItemInternal: function(key, item, size, resolve, reject) {},
    // NOTE: This is the spelling from the API
    setSentinalItem: function() {},
    suspendSweeping: function() {},
    sweep: function() {}
};

/**
@type {DefDescriptor}
@const
*/
DefDescriptor = {};
DefDescriptor.prototype = {
    // Methods
    getName: function() {},
    getNamespace: function() {},
    getPrefix: function() {},
    getQualifiedName: function() {},
    normalize: function() {},
    toString: function() {}
};

/**
@type {DocLevelHandler}
@const
*/
DocLevelHandler = {};
DocLevelHandler.prototype = {
    // Methods
    callback: function() {},
    setEnabled: function(enabled) {}
};

/**
@type {DomHandlersPlugin}
@const
*/
DomHandlersPlugin = {};
DomHandlersPlugin.prototype = {
    // Methods
    bind: function() {},
    disable: function() {},
    dispatchActionHook: function() {},
    dispatchVirtualActionHook: function() {},
    enable: function() {},
    initialize: function() {},
    postProcess: function() {},
    unbind: function() {}
};

/**
@type {Entry}
@const
*/
Entry = {};
Entry.prototype = {
    // Methods
    getItem: function() {},
    getSize: function() {}
};

/**
@type {Event}
@const
*/
Event = {};
Event.prototype = {
    // Methods
    dispatchComponentEventHandlers: function() {},
    dispatchNonComponentEventHandlers: function() {},
    fire: function(params) {},
    getDef: function() {},
    getName: function() {},
    getParam: function(name) {},
    getParams: function() {},
    getSource: function() {},
    setComponentEvent: function() {},
    setParam: function(key, value) {},
    getParams: function(config) {},
    stopPropagation: function(bubble) {}
};

/**
@type {EventDef}
@const
*/
EventDef = {};
EventDef.prototype = {
    // Methods
    getAttributeDefs: function() {},
    getDescriptor: function() {},
    getEventType: function() {},
    getSuperDef: function() {}
};

/**
@type {ExpressionFunctions}
@const
*/
ExpressionFunctions = {};
ExpressionFunctions.prototype = {
    // Properties
    empty: null,

    // Methods
    add: function(a, b) {},
    eq: function(a, b) {},
    format: function() {},
    join: function() {},
    ne: function(a, b) {},
    token: function() {}
};

/**
@type {FlavorsDef}
@const
*/
FlavorsDef = {};
FlavorsDef.prototype = {
    // Methods
    getFlavor: function(componentDescriptor) {}
};

/**
@type {FunctionCallValue}
@const
*/
FunctionCallValue = {};
FunctionCallValue.prototype = {
    // Properties
    expressionFunctions: null,

    // Methods
    addChangeHandler: function() {},
    destroy: function() {},
    evaluate: function(valueProvider) {},
    getChangeHandler: function() {},
    isDirty: function() {},
    removeChangeHandler: function() {},
    toString: function() {}
};

/**
@type {GlobalValueProviders}
@const
*/
GlobalValueProviders = {};
GlobalValueProviders.prototype = {
    // Properties
    LOADED_FROM_PERSISTENT_STORAGE: false,
    MUTEX_KEY: null,
    STORAGE_KEY: null,
    mutexUnlock: null,

    // Methods
    get: function(expression, component) {}
};

/**
@type {IndexedDBAdapter}
@const
*/
IndexedDBAdapter = {};
IndexedDBAdapter.prototype = {
    // Properties
    LOG_LEVEL: null,
    NAME: null,

    // Methods
    clear: function() {},
    clearInternal: function(resolve, reject) {},
    clearOnInit: function() {},
    deleteStorage: function() {},
    enqueue: function(execute) {},
    expireCache: function(requestedSize, resolve, reject) {},
    getAll: function() {},
    getItem: function(key) {},
    getName: function() {},
    getSize: function() {},
    register: function() {},
    removeItem: function(key) {},
    removeItemInternal: function(key, resolve, reject) {},
    resumeSweeping: function() {},
    setItem: function(key, item, size) {},
    setItemInternal: function(key, item, size, resolve, reject) {},
    suspendSweeping: function() {},
    sweep: function() {},
    updateSize: function(sizeChange, error) {},
    walkInternal: function(resolve, reject, sendResult) {}
};

/**
@type {InvalidComponent}
@const
*/
InvalidComponent = {};
InvalidComponent.prototype = {
    // Methods
    addHandler: function() {},
    addValueHandler: function() {},
    destroy: function() {},
    find: function() {},
    finishDestroy: function() {},
    get: function() {},
    getConcreteComponent: function() {},
    getDef: function() {},
    getElement: function() {},
    getElements: function() {},
    getEvent: function() {},
    getEventDispatcher: function() {},
    getFacets: function() {},
    getGlobalId: function() {},
    getLocalId: function() {},
    getModel: function() {},
    getRendering: function() {},
    isConcrete: function() {},
    isInstanceOf: function() {},
    isValid: function() {},
    removeValueHandler: function() {},
    set: function() {},
    toString: function() {}
};

/**
@type {JSON}
@const
*/
JSON = {};
JSON.prototype = {
    // Properties
    orderedEncode: null,

    // Methods
    _resolveRefs: function() {},
    decode: function(json, refSupport) {},
    decodeString: function(value) {},
    encode: function(obj, replacer, whiteSpace) {},
    encodeFunction: function(value) {},
    resolveRefsArray: function(array) {},
    resolveRefsObject: function(object) {}
};

/**
@type {LabelQueue}
@const
*/
LabelQueue = {};
LabelQueue.prototype = {
    // Methods
    addCallback: function(callback) {},
    addComponent: function(component) {},
    addReturnValue: function(value) {},
    getCallbacks: function() {},
    getComponents: function() {},
    getReturnValues: function() {},
    isRequested: function() {},
    reset: function() {},
    setRequested: function() {}
};

/**
@type {LabelValueProvider}
@const
*/
LabelValueProvider = {};
LabelValueProvider.prototype = {
    // Methods
    get: function(expression, component, callback) {},
    getQueue: function(section, name) {},
    getQueueKey: function(section, name) {},
    getValues: function() {},
    merge: function() {},
    removeQueue: function(section, name) {}
};

/**
@type {LibraryIncludeRegistry}
@const
*/
LibraryIncludeRegistry = {};
LibraryIncludeRegistry.prototype = {
    // Methods
    addLibraryInclude: function(descriptor, dependencies, exporter) {},
    buildLibraryInclude: function(dependencies) {},
    clearDependencyQueue: function() {},
    cloneDependencyQueue: function() {},
    dequeueDependency: function(descriptor) {},
    enqueueDependency: function(descriptor) {},
    getLibraryInclude: function(descriptor) {},
    hasDependencyQueue: function() {},
    hasDependencyQueueChanged: function() {},
    hasLibraryInclude: function(descriptor) {}
};

/**
@type {LibraryRegistry}
@const
*/
LibraryRegistry = {};
LibraryRegistry.prototype = {
    // Methods
    addLibrary: function(descriptor, includes) {},
    buildLibrary: function(includes) {},
    getLibrary: function(descriptor) {},
    hasLibrary: function(descriptor) {},
    initLibraries: function(library) {}
};

/**
@type {Logger}
@const
*/
Logger = {};
Logger.prototype = {
    // Methods
    adjustSubscriptions: function(level, adjustment) {},
    assert: function(condition, message) {},
    error: function(message, error) {},
    getStackTrace: function(error, remove) {},
    hasSubscriptions: function(level) {},
    info: function(message, error) {},
    isValidLevel: function(level) {},
    isValidSubscriber: function(level, callback) {},
    log: function(level, message, error) {},
    notify: function(level, message, error) {},
    reportError: function() {},
    stringVersion: function(logMessage, error, trace) {},
    subscribe: function(level, callback) {},
    unsubscribe: function(level, callback) {},
    warning: function(message, error) {}
};

/**
@type {MemoryAdapter}
@const
*/
MemoryAdapter = {};
MemoryAdapter.prototype = {
    // Properties
    LOG_LEVEL: null,

    // Methods
    clear: function() {},
    deleteStorage: function() {},
    expireCache: function(spaceNeeded) {},
    getAll: function() {},
    getItem: function(key) {},
    getMRU: function() {},
    getName: function() {},
    getSize: function() {},
    removeItem: function(key) {},
    removeItemInternal: function(key) {},
    reset: function() {},
    setItem: function(key, item, size) {},
    sweep: function() {},
    updateMRU: function(key) {}
};

/**
@type {MethodDef}
@const
*/
MethodDef = {};
MethodDef.prototype = {
    // Methods
    getDescriptor: function() {}
};

/**
@type {MetricsService}
@const
*/
MetricsService = {};
MetricsService.prototype = {
    // Methods
    clearMarks: function(namespace) {},
    clearTransactions: function() {},
    detachHandlerOfType: function(callback, name) {},
    detachOnKilledTransactions: function(callback) {},
    detachOnTransactionEnd: function(callback) {},
    disablePlugin: function(name) {},
    disablePlugins: function() {},
    enablePlugin: function(name) {},
    enablePlugins: function() {},
    getBootstrapMetrics: function() {},
    getCurrentMarks: function() {},
    getCurrentPageTransaction: function() {},
    getTransaction: function(namespace, id) {},
    getTransactions: function() {},
    getVersion: function() {},
    inTransaction: function() {},
    instrument: function(instance, method, namespace, async, before, after, override) {},
    mark: function(namespace, name, context) {},
    markEnd: function(namespace, name, context) {},
    markStart: function(namespace, name, context) {},
    microsecondsResolution: function() {},
    onTransactionEnd: function(callback) {},
    onTransactionsKilled: function(callback) {},
    registerBeacon: function(beacon) {},
    registerPlugin: function(pluginConfig) {},
    setClearCompletedTransactions: function() {},
    syntheticTransactionStart: function(namespace, name, transaction) {},
    time: function(mark, value) {},
    transaction: function(namespace, id, config) {},
    transactionEnd: function(namespace, id, config) {},
    transactionStart: function(namespace, id, config) {},
    transactionUpdate: function(namespace, id, config) {},
    unInstrument: function(instance, method) {}
};

/**
@type {Model}
@const
*/
Model = {};
Model.prototype = {
    // Methods
    destroy: function() {},
    get: function() {},
    set: function() {}
};

/**
@type {ModelDef}
@const
*/
ModelDef = {};
ModelDef.prototype = {
    // Methods
    getDescriptor: function() {},
    getMembers: function() {},
    newInstance: function(config, component) {}
};

/**
@type {Mutex}
@const
*/
Mutex = {};
Mutex.prototype = {
    // Methods
    _clearLock: function() {},
    _execute: function() {},
    _getX: function() {},
    _getY: function() {},
    _isLockAvailable: function() {},
    _lockPriv: function() {},
    _retry: function() {},
    _setX: function() {},
    _setY: function() {},
    getClientId: function() {},
    hasLock: function() {},
    lock: function(key, callback, timeout) {}
};

/**
@type {NumberFormat}
@const
*/
NumberFormat = {};
NumberFormat.prototype = {
    // Methods
    format: function(number) {},
    parseError: function() {}
};

/**
@type {ObjectValueProvider}
@const
*/
ObjectValueProvider = {};
ObjectValueProvider.prototype = {
    // Methods
    get: function(expression, callback) {},
    getValues: function() {},
    merge: function(values) {}
};

/**
@type {Override}
@const
*/
Override = {};
Override.prototype = {
    // Methods
    continuation: function() {},
    install: function(func, scope, priority) {},
    start: function() {},
    uninstall: function(func) {}
};

/**
@type {PassthroughValue}
@const
*/
PassthroughValue = {};
PassthroughValue.prototype = {
    // Methods
    addValueHandler: function() {},
    deIndex: function() {},
    fireChangeEvent: function() {},
    get: function(key) {},
    getComponent: function() {},
    getDef: function() {},
    getExpression: function(expression) {},
    getPrimaryProviderKeys: function() {},
    getReference: function(key) {},
    index: function() {},
    isValid: function() {},
    removeValueHandler: function() {},
    set: function(key, value) {}
};

/**
@type {PerfMetricsPlugin}
@const
*/
PerfMetricsPlugin = {};
PerfMetricsPlugin.prototype = {
    // Methods
    bind: function() {},
    disable: function() {},
    enable: function() {},
    initialize: function() {},
    postProcess: function() {},
    processResponsesOverride: function() {},
    unbind: function() {}
};

/**
@type {PropertyReferenceValue}
@const
*/
PropertyReferenceValue = {};
PropertyReferenceValue.prototype = {
    // Methods
    addChangeHandler: function() {},
    destroy: function() {},
    equals: function() {},
    evaluate: function() {},
    getExpression: function() {},
    getReference: function() {},
    isDirty: function() {},
    removeChangeHandler: function() {},
    set: function() {},
    toJSON: function() {},
    toString: function() {}
};

/**
@type {QueuedActionMetricsPlugin}
@const
*/
QueuedActionMetricsPlugin = {};
QueuedActionMetricsPlugin.prototype = {
    // Methods
    actionFinishOverride: function() {},
    actionSendOverride: function() {},
    bind: function() {},
    disable: function() {},
    enable: function() {},
    enqueueActionOverride: function() {},
    initialize: function() {},
    markStart: function() {},
    markEnd: function() {},
    postProcess: function() {},
    unbind: function() {}
};

/**
@type {RequiredVersionDef}
@const
*/
RequiredVersionDef = {};
RequiredVersionDef.prototype = {
    // Methods
    getDescriptor: function() {},
    getNamespace: function() {},
    getVersion: function() {}
};

/**
@type {RequiredVersionDefSet}
@const
*/
RequiredVersionDefSet = {};
RequiredVersionDefSet.prototype = {
    // Methods
    getDef: function(name) {}
};

/**
@type {ResultSet}
@const
*/
ResultSet = {};
ResultSet.prototype = {
    // Methods
    diff: function() {}
};

/**
@type {SizeEstimator}
@const
*/
SizeEstimator = {};
SizeEstimator.prototype = {
    // Methods
    estimateSize: function(value) {},
    sizeOfString: function() {}
};

/**
@type {Statement}
@const
*/
Statement = {};
Statement.prototype = {
    // Methods
    field: function() {},
    from: function() {},
    groupBy: function() {},
    query: function() {},
    where: function() {}
};

/**
@type {Style}
@const
*/
Style = {};
Style.prototype = {
    // Methods
    getCSSProperty: function(element, cssProperty) {},
    getHead: function() {},
    include: function(href) {}
};

/**
@type {StyleDef}
@const
*/
StyleDef = {};
StyleDef.prototype = {
    // Methods
    apply: function() {},
    getClassName: function(className) {},
    getDescriptor: function() {},
    isPreloaded: function() {},
    remove: function() {}
};

/**
@type {Test}
@const
*/
Test = {};
Test.prototype = {
    // Methods
    addCleanup: function(cleanupFunction) {},
    addEventHandler: function(eventName, handler, component, insert) {},
    addFunctionHandler: function(instance, name, newFunction, postProcess) {},
    addPostDecodeCallback: function() {},
    addPostSendCallback: function(action, postSendCallback) {},
    addPreDecodeCallback: function() {},
    addPreSendCallback: function(action, preSendCallback) {},
    addWaitFor: function(expected, testFunction, callback) {},
    addWaitForWithFailureMessage: function(expected, testFunction, failureMessage, callback) {},
    areActionsComplete: function() {},
    assertAccessible: function(errorMessage) {},
    assertAuraType: function(type, condition, assertMessage) {},
    assertDefined: function(condition, assertMessage) {},
    assertEquals: function(arg1, arg2, assertMessage) {},
    assertEqualsIgnoreWhitespace: function(arg1, arg2, assertMessage) {},
    assertFalse: function(condition, assertMessage) {},
    assertFalsy: function(condition, assertMessage) {},
    assertNotEquals: function(arg1, arg2, assertMessage) {},
    assertNotNull: function(condition, assertMessage) {},
    assertNotNullOrUndefined: function(condition, assertMessage) {},
    assertNull: function(condition, assertMessage) {},
    assertStartsWith: function(start, full, assertMessage) {},
    assertTrue: function(condition, assertMessage) {},
    assertUndefined: function(condition, assertMessage) {},
    assertUndefinedOrNull: function(condition, assertMessage) {},
    blockBackgroundRequests: function() {},
    blockForegroundRequests: function() {},
    blockRequests: function() {},
    callServerAction: function(action, doImmediate) {},
    checkGlobalNamespacePollution: function() {},
    clearAndAssertComponentConfigs: function(action) {},
    clickOrTouch: function(element, canBubble, cancelable) {},
    compareValues: function(expected, actual) {},
    contains: function(testString, targetString) {},
    createHttpRequest: function() {},
    dummyFunction: function() {},
    enqueueAction: function(action, background) {},
    executeAfterCkEditorIsReady: function(richTextInputComponent, callback) {},
    expectAuraError: function(message) {},
    expectAuraWarning: function(message) {},
    fail: function(assertMessage, extraInfoMessage) {},
    findChildWithClassName: function(parentElement, className) {},
    fireDomEvent: function(element, eventName, canBubble, cancelable) {},
    getAction: function(component, name, params, callback) {},
    getActiveElement: function() {},
    getActiveElementText: function() {},
    getAppCacheEvents: function() {},
    getAuraErrorMessage: function() {},
    getCreationPath: function() {},
    getDump: function() {},
    getElementAttributeValue: function(element, attributeName) {},
    getElementByClass: function(className) {},
    getErrors: function() {},
    getExternalAction: function(component, descriptor, params, returnType, callback) {},
    getGlobalValueProviders: function(type) {},
    getNonCommentNodes: function(nodes) {},
    getOuterHtml: function(node) {},
    getPrototype: function(instance) {},
    getSentRequestContent: function() {},
    getStyle: function(element, style) {},
    getText: function(node) {},
    getTextByComponent: function(component) {},
    isActionPending: function() {},
    isActionQueued: function() {},
    isComplete: function() {},
    isInstanceOf: function(element, elementType, tag) {},
    isInstanceOfAnchorElement: function(element) {},
    isInstanceOfButtonElement: function(element) {},
    isInstanceOfDivElement: function(element) {},
    isInstanceOfImageElement: function(element) {},
    isInstanceOfInputElement: function(element) {},
    isInstanceOfLiElement: function(element) {},
    isInstanceOfParagraphElement: function(element) {},
    isInstanceOfSpanElement: function(element) {},
    isInstanceOfText: function(node) {},
    isNodeDeleted: function(node) {},
    overrideFunction: function(instance, name, newFunction) {},
    releaseBackgroundRequests: function() {},
    releaseForegroundRequests: function() {},
    releaseRequests: function() {},
    reloadGlobalValueProviders: function(gvp, callback) {},
    removePostDecodeCallback: function() {},
    removePostSendCallback: function() {},
    removePreDecodeCallback: function() {},
    removePrePostSendCallback: function() {},
    removePreSendCallback: function() {},
    run: function(name, code, timeoutOverride) {},
    runActionsAsTransaction: function(actions, scope, callback) {},
    runAfterIf: function(conditionFunction, callback, intervalInMs) {},
    select: function() {},
    setServerReachable: function(reachable) {},
    setTestTimeout: function(timeoutMillis) {}
};

/**
@type {TransportMetricsPlugin}
@const
*/
TransportMetricsPlugin = {};
TransportMetricsPlugin.prototype = {
    // Methods
    bind: function() {},
    disable: function() {},
    enable: function() {},
    initialize: function() {},
    postProcess: function() {},
    receiveOverride: function() {},
    sendOverride: function() {},
    unbind: function() {}
};

/**
@type {Util}
@const
*/
Util = {};
Util.prototype = {
    // Properties
    // TODO: These seem more like methods
    bind: null,
    every: null,
    filter: null,
    forEach: null,
    isIE: null,
    map: null,
    on: null,
    reduce: null,
    sanitizeCSS: null,
    sanitizeHtml: null,
    sanitizeJs: null,
    sanitizeJsAttr: null,
    sanitizeJsObj: null,
    sanitizeStyle: null,
    sanitizeUri: null,
    some: null,

    // Methods
    acceptsData: function(element) {},
    addClass: function(element, newClass) {},
    addMapValueToMap: function(inputMap, key, value, subMapKey) {},
    addValueToMap: function(inputMap, key, value) {},
    appendChild: function(newElement, referenceElement) {},
    apply: function(baseObject, members, forceCopy, deepCopy) {},
    attachToDocumentBody: function(element) {},
    bind: function(method, bound, args) {},
    buildFlavorClass: function(component) {},
    camelCaseToHyphens: function(string) {},
    clearNode: function(node) {},
    compareValues: function(expected, actual) {},
    contains: function(container, element) {},
    copy: function(value) {},
    createElementsFromMarkup: function(markup) {},
    createHtmlElement: function(tagName, attributes) {},
    createTimeoutCallback: function(callback, toleranceMillis) {},
    estimateSize: function(item) {},
    every: function(array, predicate, instance) {},
    filter: function(predicate, instance) {},
    forEach: function(array, func, instance) {},
    formToMap: function(form) {},
    format: function(formatString, args) {},
    generateUrl: function(url, params, encoded) {},
    getBooleanValue: function(val) {},
    getDataAttribute: function(element, key) {},
    getDebugToolComponent: function() {},
    getDebugToolsAuraInstance: function() {},
    getElement: function(id) {},
    getElementAttributeValue: function(element, attributeName) {},
    getSelected: function(select) {},
    getText: function(node) {},
    getUrl: function() {},
    getWindowSize: function() {},
    hasClass: function(element, className) {},
    hasDataAttribute: function(element, key) {},
    hyphensToCamelCase: function(string) {},
    includeScript: function(url, callback) {},
    insertAfter: function(newElement, referenceElement) {},
    insertBefore: function(newElement, referenceElement) {},
    insertFirst: function(newElement, referenceElement) {},
    instanceOf: function(instance, constructor) {},
    isAction: function(object) {},
    isArray: function(object) {},
    isBoolean: function(object) {},
    isComponent: function(object) {},
    isElement: function(object) {},
    isEmpty: function(object) {},
    isError: function(object) {},
    isExpression: function(object) {},
    isFiniteNumber: function(object) {},
    isFunction: function(object) {},
    isIOSWebView: function() {},
    isLocalStorageEnabled: function() {},
    isNumber: function(object) {},
    isObject: function(object) {},
    isPlainObject: function(object) {},
    isString: function(object) {},
    isSubDef: function(def, qname) {},
    isUndefined: function(object) {},
    isUndefinedOrNull: function(object) {},
    isValue: function(object) {},
    lookup: function(root, args) {},
    map: function(array, transforms, instance) {},
    merge: function(array, args) {},
    reduce: function(array, reduction, instance) {},
    removeClass: function(element, newClass) {},
    removeElement: function(element) {},
    removeOn: function(element, eventName, listener, useCapture) {},
    setDataAttribute: function(element, key, value) {},
    setDebugToolWindow: function() {},
    setText: function() {},
    some: function(array, predicate, instance) {},
    squash: function(event, preventDefault) {},
    stringEndsWith: function(fullString, substring) {},
    stripTags: function(input, tags) {},
    supportsTouchEvents: function() {},
    swapClass: function(element, oldClass, newClass) {},
    toArray: function() {},
    toggleClass: function(element, className) {},
    trim: function(value) {},
    truncate: function(string, length, ellipsis, truncateByWord) {}
};

/**
@type {ValueDef}
@const
*/
ValueDef = {};
ValueDef.prototype = {
    // Methods
    getName: function() {}
};
