/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * Handles retrieval of ComponentDefs from the server
 * @constructor
 */
function ComponentDefLoader() {}

// params start with "_" to avoid namespace collisions
ComponentDefLoader.UID_param = "_uid";
ComponentDefLoader.DESCRIPTOR_param = "_def";
ComponentDefLoader.APP_param = "aura.app";
ComponentDefLoader.HYDRATION_param = "_hydration";
ComponentDefLoader.LOCKER_param = "_l";
ComponentDefLoader.STYLE_param = "_style";
ComponentDefLoader.LOCALE_param = "_l10n";
ComponentDefLoader.UID_default = "LATEST";
ComponentDefLoader.BASE_PATH = "/auraCmpDef?";
ComponentDefLoader.MARKUP_param = "markup://";

ComponentDefLoader.prototype.buildComponentUri = function(descriptor, uid) {};

ComponentDefLoader.prototype.buildURIAppParam = function() {};

ComponentDefLoader.prototype.buildURIHydrationParam = function(hydration) {};

ComponentDefLoader.prototype.buildURILockerParam = function() {};

ComponentDefLoader.prototype.buildURIStyleParam = function() {};

ComponentDefLoader.prototype.buildURILocaleParam = function() {};

ComponentDefLoader.prototype.getHydrationState = function() {};

ComponentDefLoader.prototype.buildBundleComponentNamespace = function(descriptors, descriptorMap) {};

ComponentDefLoader.prototype.buildBundleComponentUri = function(descriptorMap) {};

ComponentDefLoader.prototype.buildURIString = function(uri, uid, descriptors) {};

ComponentDefLoader.prototype.getScriptPromises = function(descriptorMap) {};

ComponentDefLoader.prototype.retrievePending = function(pending) {};

// Exists only so that instrumentation can hook into script tag load completes
// Called when all the script tags have finished loading. Hook defined in Aura_exports override map
// ComponentDefLoader.loadingComplete
ComponentDefLoader.prototype.loadingComplete = function() {};

ComponentDefLoader.prototype.checkForError = function (uri, resolve, reject) {};

ComponentDefLoader.prototype.onerror = function(uri, reject){};

ComponentDefLoader.prototype.generateScriptTag = function(uri) {};

ComponentDefLoader.prototype.schedulePending = function() {};

ComponentDefLoader.prototype.loadComponentDef = function(descriptor, uid, callback) {};

ComponentDefLoader.prototype.loadComponentDefs = function(descriptorMap, callback) {};

Aura.Component.ComponentDefLoader = ComponentDefLoader;
