/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @description Creates a new ControllerDef, including the descriptor and action definitions.
 * A ControllerDef instance is created as part of the ComponentDef initialization.
 * @constructor
 * @param {Object} config
 * @export
 */
function ControllerDef(config){}

/**
 * Gets the Controller Descriptor with the format <code>markup://aura:component</code>.
 * @returns {String} ControllerDef descriptor
 */
ControllerDef.prototype.getDescriptor = function(){};

/**
 * Check if an action def exists.
 */
ControllerDef.prototype.hasActionDef = function(key){};

/**
 * Gets the Action Definition.
 * @param {String} key - A action name which is defined on the controller.
 * @returns {ActionDef} an action definition, undefined if the definition does not exist.
 */
ControllerDef.prototype.getActionDef = function(key) {};

/**
 * Gets a new Action instance based on the given key.
 * @param {String} key - A action name which is defined on the controller.
 * @returns {Action} A new Action instance
 */
ControllerDef.prototype.get = function(key){};

Aura.Controller.ControllerDef = ControllerDef;
