/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @description Creates an AuraError instance.
 * @constructor
 * @param {String} message - the detail message about the error.
 * @param {Object} innerError - an Error object whose properties are to be placed into AuraError.
 * @param {String} severity - the severity of the error. Aura built-in values are defined in $A.severity.
 */
function AuraError(message, innerError, severity) {}

/* port murmur32 from guava */
Aura.Errors.MurmurHash3 = {
    mul32: function(m, n) {},

    hashString: function(data) {}
};

Aura.Errors.GenerateErrorId = function(hashGen) {};

Aura.Errors.GenerateErrorIdHashGen = function(componentName, stackFrames) {};

AuraError.prototype = new Error();
AuraError.prototype.constructor = AuraError;
AuraError.prototype.toString = function() {};

/**
 * When there is need to mess with stacktrace, call this method
 * @function
 * @param {String} trace - The trace to be set to this error instance.
 */
AuraError.prototype.setStackTrace = function(trace) {};

/**
 * Returns the failing component descriptor based on stacktrace
 */
AuraError.prototype.findComponentFromStackTrace = function() {};

AuraError.prototype.setComponent = function(component) {};

Aura.Errors.AuraError = AuraError;
