/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

 /**
  * This is internal Locker API. We can export those methods because we know that there is never
  * more than one LockerService instance created (otherwise these would be overwritten), and
  * because all Aura objects are created inside an IIC function (otherwise objects would be
  * exported on window and available outside of Aura Framework). 
  */

var ls_getKey,
    ls_setKey,
    ls_trust,
    ls_hasAccess,
    ls_verifyAccess,
    ls_getRef,
    ls_setRef,
    ls_getData,
    ls_setData,
    ls_isOpaque,
    ls_unwrap,
    ls_addToCache,
    ls_getFromCache,
    ls_isProxy,
    ls_registerProxy,
    ls_registerFilteringProxy,
    ls_isFilteringProxy,
    ls_registerSecureFunction,
    ls_isSecureFunction;

(function LockerKeyManager() {}());
