/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


/**
 * Construct a SecureRTCPeerConnection wrapper.
 * Note: This is a temporary wrapper for SPARK team only. Not exposed to any external customers.
 *
 * @public
 * @class
 * @constructor
 */
function SecureRTCPeerConnection(raw, key) {}

// TODO: The following metadata is for future use
var DEFAULT = SecureElement.DEFAULT;
var EVENT = SecureElement.EVENT;
var FUNCTION = SecureElement.FUNCTION;
var FUNCTION_RAW_ARGS = SecureElement.FUNCTION_RAW_ARGS;
var READ_ONLY_PROPERTY = { writable : false };
var RAW = { type: "@raw" };

SecureRTCPeerConnection.metadata = {
    "prototypes": {
        "RTCPeerConnection" : {
            "addIceCandidate" :                 FUNCTION_RAW_ARGS,
            "addStream" :                       FUNCTION_RAW_ARGS,
            "addTrack" :                        FUNCTION_RAW_ARGS,
            "canTrickleIceCandidates" :         DEFAULT,
            "close" :                           FUNCTION,
            "connectionState":                  DEFAULT,
            "createAnswer" :                    FUNCTION,
            "createOffer" :                     FUNCTION,
            "currentLocalDescription" :         DEFAULT,
            "currentRemoteDescription" :        DEFAULT,
            "defaultIceServers" :               DEFAULT,
            "generateCertificate" :             FUNCTION,
            "getConfiguration" :                FUNCTION,
            "getIdentityAssertion" :            FUNCTION,
            "getLocalStreams" :                 FUNCTION,
            "getRemoteStreams" :                FUNCTION,
            "getSenders" :                      FUNCTION,
            "getStats" :                        FUNCTION,
            "getStreamById" :                   FUNCTION,
            "iceConnectionState" :              READ_ONLY_PROPERTY,
            "iceGatheringState " :              READ_ONLY_PROPERTY,
            "localDescription" :                READ_ONLY_PROPERTY,
            "onaddstream" :                     EVENT,
            "onconnectionstatechange" :         EVENT,
            "ondatachannel " :                  EVENT,
            "onicecandidate" :                  EVENT,
            "oniceconnectionstatechange" :      EVENT,
            "onicegatheringstatechange" :       EVENT,
            "onidentityresult" :                EVENT,
            "onidpassertionerror " :            EVENT,
            "onidpvalidationerror" :            EVENT,
            "onnegotiationneeded " :            EVENT,
            "onpeeridentity" :                  EVENT,
            "onremovestream" :                  EVENT,
            "onsignalingstatechange " :         EVENT,
            "ontrack" :                         EVENT,
            "peerIdentity" :                    READ_ONLY_PROPERTY,
            "pendingLocalDescription" :         DEFAULT,
            "pendingRemoteDescription" :        READ_ONLY_PROPERTY,
            "remoteDescription" :               READ_ONLY_PROPERTY,
            "removeStream" :                    FUNCTION_RAW_ARGS,
            "removeTrack" :                     FUNCTION_RAW_ARGS,
            "sctp" :                            DEFAULT,
            "setConfiguration" :                FUNCTION_RAW_ARGS,
            "setIdentityProvider" :             FUNCTION,
            "setLocalDescription" :             FUNCTION_RAW_ARGS,
            "setRemoteDescription" :            FUNCTION_RAW_ARGS,
            "signalingState" :                  READ_ONLY_PROPERTY
        }
    }
};
