/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * AuraContextPlugin
 * =================
 * This plugin hooks into the Aura Context object.
 * In particular the following methods:
 * merge(): Tracks the component defs that are sent dynamically to the client.
 *
 * @description AuraContextPlugin
 * @constructor
 * @export
 */
var AuraContextPlugin = function AuraContextPlugin(config) {};

AuraContextPlugin.NAME = "defRegistry";

/** @export */
AuraContextPlugin.prototype.initialize = function (metricsService) {};

/** @export */
AuraContextPlugin.prototype.enable = function () {};

/** @export */
AuraContextPlugin.prototype.disable = function () {};

AuraContextPlugin.prototype.bind = function (metricsService) {};

//#if {"excludeModes" : ["PRODUCTION"]}
/** @export */
AuraContextPlugin.prototype.postProcess = function (transportMarks) {};
//#end

AuraContextPlugin.prototype.unbind = function (metricsService) {};

$A.metricsService.registerPlugin({
    "name"   : AuraContextPlugin.NAME,
    "plugin" : AuraContextPlugin
});
