/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * ComponentServiceMetricsPlugin
 * =================
 * This plugin hooks into the ComponentService.
 * In particular the following methods:
 * createComponentPriv(): Tracks the component creation time for all components
 *
 * @description ComponentServiceMetricsPlugin
 * @constructor
 * @export
 */
var ComponentServiceMetricsPlugin = function ComponentServiceMetricsPlugin(config) {};

ComponentServiceMetricsPlugin.NAME = "componentService";

/** @export */
ComponentServiceMetricsPlugin.prototype.initialize = function (metricsService) {};

/** @export */
ComponentServiceMetricsPlugin.prototype.enable = function () {};

/** @export */
ComponentServiceMetricsPlugin.prototype.disable = function () {};

ComponentServiceMetricsPlugin.prototype.createComponentOverride = function () {};

ComponentServiceMetricsPlugin.prototype.bind = function () {};

//#if {"excludeModes" : ["PRODUCTION"]}
/** @export */
ComponentServiceMetricsPlugin.prototype.postProcess = function (componentMarks) {};
//#end	

ComponentServiceMetricsPlugin.prototype.unbind = function () {};

$A.metricsService.registerPlugin({
    "name"   : ComponentServiceMetricsPlugin.NAME,
    "plugin" : ComponentServiceMetricsPlugin
});
