/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * QueuedActionsMetricsPlugin
 * =================
 * This plugin tracks the state and result of all actions from the framework
 * @description Queued Action metrics plugin
 * @constructor
 * @export
 */
var QueuedActionsMetricsPlugin = function QueuedActionsMetricsPlugin(config) {};

QueuedActionsMetricsPlugin.NAME = "actions";

/** @export */
QueuedActionsMetricsPlugin.prototype.initialize = function (metricsService) {};

/** @export */
QueuedActionsMetricsPlugin.prototype.enable = function () {};

/** @export */
QueuedActionsMetricsPlugin.prototype.disable = function () {};

QueuedActionsMetricsPlugin.prototype.enqueueActionOverride = function() {};

QueuedActionsMetricsPlugin.prototype.collectServerActionOverride = function() {};

QueuedActionsMetricsPlugin.prototype.actionSendOverride = function() {};

QueuedActionsMetricsPlugin.prototype.actionFinishOverride = function() {};

QueuedActionsMetricsPlugin.prototype.actionsProcessResponses = function() {};

QueuedActionsMetricsPlugin.prototype.bind = function () {};

/** @export */
QueuedActionsMetricsPlugin.prototype.postProcess = function (actionMarks /*, trxConfig*/) {};

QueuedActionsMetricsPlugin.prototype.unbind = function () {};

$A.metricsService.registerPlugin({
    "name"   : QueuedActionsMetricsPlugin.NAME,
    "plugin" : QueuedActionsMetricsPlugin
});
