/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * TransportMetricsPlugin
 * =================
 * This plugin tracks information about all XHRs done to the aura servlet
 * @description Transport metrics plugin
 * @constructor
 * @export
 */
var TransportMetricsPlugin = function TransportMetricsPlugin(config) {};

TransportMetricsPlugin.NAME = "transport";
TransportMetricsPlugin.ORIGIN = window.location && window.location.origin;
TransportMetricsPlugin.AURA_URL = TransportMetricsPlugin.ORIGIN + '/aura';

/** @export */
TransportMetricsPlugin.prototype.initialize = function (metricsService) {};

/** @export */
TransportMetricsPlugin.prototype.enable = function () {};

/** @export */
TransportMetricsPlugin.prototype.disable = function () {};

TransportMetricsPlugin.prototype.sendOverride = function (/* config, auraXHR, actions, method, options */) {};

TransportMetricsPlugin.prototype.receiveOverride = function(/* config, auraXHR */) {};

TransportMetricsPlugin.prototype.bind = function () {};

/** @export */
TransportMetricsPlugin.prototype.postProcess = function (transportMarks) {};

TransportMetricsPlugin.prototype.unbind = function () {};

$A.metricsService.registerPlugin({
    "name"   : TransportMetricsPlugin.NAME,
    "plugin" : TransportMetricsPlugin
});
