/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @description Creates a new ModelDef instance.
 * @constructor
 * @export
 */
function ModelDef(config){}

/**
 * Gets the descriptor. (e.g. markup://foo:bar)
 * @returns {DefDescriptor}
 */
ModelDef.prototype.getDescriptor = function(){};

/**
 * Returns a new Model instance for this component.
 * @param {Object} config
 * @returns {Model}
 */
ModelDef.prototype.newInstance = function(config){};

/**
 * Gets member value defs containing ValueDef and TypeDef.
 * @returns {Object}
 */
ModelDef.prototype.getMembers = function() {};

Aura.Model.ModelDef = ModelDef;
