/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @description Context's Global ValueProvider.
 * @constructor
 */
function ContextValueProvider(values) {}

/**
 * returns $Global values
 *
 * @protected
 * @return {Object} a copy of the internal store.
 */
ContextValueProvider.prototype.getValues = function() {};

/**
 * Returns a storable set of values.
 *
 * @private
 * @return {Object} a reference to the internal store.
 */
ContextValueProvider.prototype.getStorableValues = function() {};

ContextValueProvider.prototype.serializeForServer = function () {};

/**
 * Merges $Global values.
 *
 * The incoming values must be from the server. We have special handling here to ensure that the
 * server does not overwrite values that are on the client.
 *
 * @private
 * @param {Object} values the new set of values to merge
 */
ContextValueProvider.prototype.merge = function(values) {};

/**
 * Find value. If no value found, throw
 *
 * @public
 * @param {string} key - the key to retrieve
 * @return {Object} - the assigned of (if not assigned) default value
 */
ContextValueProvider.prototype.get = function(key) {};

/**
 * set value by name. If no value item found, throw.  If not writable, throw
 *
 * @public
 * @param {string} key - the name of the key (must exist and be writable)
 * @param {Object} value - the value to set
 * @return {Object} the value that was set.
 */
ContextValueProvider.prototype.set = function(key, value) {};

/**
 * Extract the current value from the global value.
 *
 * @private
 * @param {Object} the global value (keys = [ "value", "defaultValue", "writable" ]
 * @return {Object} the value
 */
ContextValueProvider.prototype.extract = function(gv) {};

Aura.Provider.ContextValueProvider = ContextValueProvider;