/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @description Creates a new DefDescriptor (definition descriptor) instance, including the prefix and namespace.
 * @constructor
 * @param {Object} descriptor Throws an error if descriptor is null or undefined.
 * @export
 */
function DefDescriptor(descriptor){}

// Static Members
DefDescriptor.DESCRIPTOR="descriptor";

DefDescriptor.normalize=function(descriptor){};

/**
 * Gets the qualified name.
 * @returns {String}
 * @export
 */
DefDescriptor.prototype.getQualifiedName = function(){};

/**
 * Gets the full name.
 * @returns {String}
 * @export
 */
DefDescriptor.prototype.getFullName = function(){};

/**
 * Gets the namespace.
 * @returns {String} namespace
 * @export
 */
DefDescriptor.prototype.getNamespace = function(){};

/**
 * Gets the name part of the qualified name.
 * @returns {String}
 * @export
 */
DefDescriptor.prototype.getName = function(){};

/**
 * Gets the prefix of the DefDescriptor.
 * @returns {String}
 * @export
 */
DefDescriptor.prototype.getPrefix = function(){};

/**
 * Returns the qualified name in string format.
 * @returns {String}
 * @export
 */
DefDescriptor.prototype.toString = function(){};

Aura.System.DefDescriptor = DefDescriptor;
