/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @private
 * @function Test#putMessage
 */
TestInstance.prototype.putMessage = function(pre, expected, msg) {};

/**
 * @private
 * @function Test#expectMessage
 */
TestInstance.prototype.expectMessage = function(pre, expected, msg) {};

/**
 * Set any common entries in the two arrays to undefined.
 *
 * This is used to compare two arrays of error messages, leaving only unexpected errors received (in the pre array) and
 * expected errors not received (in the expected array).
 *
 * @private
 * @function Test#clearExpected
 */
TestInstance.prototype.clearExpected = function(pre, expected) {};

/**
 * Used to keep track of errors happening in test modes.
 *
 * @private
 * @function Test#logError
 */
TestInstance.prototype.logError = function(msg, e) {};

/**
 * Tear down a test.
 *
 * @private
 * @function Test#doTearDown
 */
TestInstance.prototype.doTearDown = function() {};

/**
 * @private
 * @function Test#logErrors
 */
TestInstance.prototype.logErrors = function(error, label, errorArray) {};

/**
 * Periodic callback to handle continuing operations.
 *
 * @private
 * @function Test#continueWhenReady
 */
TestInstance.prototype.continueWhenReady = function() {};

/**
 * Times out the test with an error.
 *
 * @private
 */
TestInstance.prototype.timeoutTest = function() {};

/**
 * Attempts to time out the test after the previously set timeout period.
 *
 * @private
 */
TestInstance.prototype.startTimer = function() {};

/**
 * Provide some information about the current state of the test.
 *
 * This is used by webdriver to get information to display.
 *
 * @export
 * @function Test#getDump
 */
TestInstance.prototype.getDump = function(clearSessionStorage) {};
