/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A representation of a set of individual bits, addressable as if organized as
 * an array.
 *
 * @constructor
 * @export
 */
Aura.Utils.Bitset = function Bitset(str) {};

/**
 * Tests whether a specific individual bit is or is not set.
 *
 * @returns {@code true} if and only if the n'th bit of the set is true.
 * @export
 */
Aura.Utils.Bitset.prototype.testBit = function(n) {};

/**
 * Causes the n'th bit of the Bitset to be set true.
 */
Aura.Utils.Bitset.prototype.setBit = function(n) {};

/**
 * Causes the n'th bit of the Bitset to be set false.
 */
Aura.Utils.Bitset.prototype.clearBit = function(n) {};

/**
 * Returns a base64 representation of the Bitset.
 */
Aura.Utils.Bitset.prototype.toString = function() {};

/**
 * Internal utility to remove trailing 0's from the bitset data.
 */
Aura.Utils.Bitset.prototype.trim = function() {};

/**
 * Internal utility to pad leading 0's onto the bitset data.
 */
Aura.Utils.Bitset.prototype.pad = function(n) {};

/**
 * Returns length of the bitset, in 6-bit words (not individual bits).
 */
Aura.Utils.Bitset.prototype.length = function() {};
// statics

Aura.Utils.Bitset.initialized = false;

Aura.Utils.Bitset.init = function() {};