/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * Duration class for AuraLocalizationService.
 *
 * We used to expose moment Duration object to framework users by $A.localizationService.duration().
 * This class is responsible for deprecating moment Duration and for the implementation of Duration.
 * All APIs in this class are deprecated and will be removed. (Those APIs were exposed to framework users
 * due to moment Duration)
 * The object of this class can be only consumed by AuraLocalizationService APIs for framework users.
 *
 * @constructor
 * @export
 */
Aura.Utils.Duration = function Duration(momentDuration) {};

Aura.Utils.Duration.prototype.getMomentDuration = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.clone = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.humanize = function(withSuffix) {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.milliseconds = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.asMilliseconds = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.seconds = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.asSeconds = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.minutes = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.asMinutes = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.hours = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.asHours = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.days = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.asDays = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.weeks = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.asWeeks = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.months = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.asMonths = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.years = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.asYears = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.add = function(number, unit) {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.subtract = function(number, unit) {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.as = function(unit) {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.get = function(unit) {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.toJSON = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.toISOString = function() {};

/**
 * @deprecated
 * @export
 * @platform
 */
Aura.Utils.Duration.prototype.locale = function(locale) {};
