/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Format is a string using the java format pattern (e.g. #,##0.0). Note that this does not handle quoted
 * special characters or exponents.
 * Symbols is an optional map of localized symbols to use, otherwise it will use the current locale's symbols
 *
 * @constructor
 * @export
 */
Aura.Utils.NumberFormat = function NumberFormat(format, symbols) {};

Aura.Utils.NumberFormat.ZERO = "0";

Aura.Utils.NumberFormat.prototype.parseError = function(s) {};

/**
 * Helper method to track special characters.
 * @private
 */
Aura.Utils.NumberFormat.prototype.checkForSpecialChar = function(c) {};

/**
 * Replaces currency markers with the local currency symbol.
 * @private
 */
Aura.Utils.NumberFormat.prototype.replaceCurrencies = function() {};

/**
 * @private
 */
Aura.Utils.NumberFormat.prototype.replaceCurrency = function(str) {};

/**
 * @private
 */
Aura.Utils.NumberFormat.prototype.translateDigits = function(charArray) {};

/**
 * Format a number into a string. Accepts a string of the format "#.#" for formatting numbers
 * requiring greater than double precision.
 * @param {Number|String} number The number to be formatted.
 * @export
 */
Aura.Utils.NumberFormat.prototype.format = function(number) {};
