/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @description A Value wrapper for a function call.
 * @constructor
 * @protected
 * @export
 */
function FunctionCallValue(config, valueProvider){}

/**
 * Create a local subclass.
 */
FunctionCallValue.prototype.expressionFunctions = new ExpressionFunctions();

/**
 * Sets the isDirty flag to false.
 * @export
 */
FunctionCallValue.prototype.isDirty = function(){};

/**
 * Returns the value of function call with the given value provider.
 * Throws an error if vp is not provided.
 * @param {Object} valueProvider The value provider to resolve.
 */
FunctionCallValue.prototype.evaluate = function(valueProvider){};

/**
 * @export
 */
FunctionCallValue.prototype.addChangeHandler=function(cmp, key, fcv) {};

FunctionCallValue.prototype.getChangeHandler=function(cmp, key, fcv) {};

/**
 * @export
 */
FunctionCallValue.prototype.removeChangeHandler=function(cmp, key){};

/**
 * Destroys the value wrapper.
 * @export
 */
FunctionCallValue.prototype.destroy = function(){};

/**
 * Returns the JS function.
 * Helpful for logging/debugging.
 * @returns {String} FunctionCallValue
 * @export
 */
FunctionCallValue.prototype.toString = function(){};

Aura.Value.FunctionCallValue = FunctionCallValue;

