/*
 * Copyright (C) 2013 salesforce.com, inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @description A Value wrapper for a property reference.
 * @constructor
 * @protected
 * @export
 */
function PropertyReferenceValue(path, valueProvider/*, target*/) {}

/**
 * Returns the dereferenced value indicated by the path supplied.
 */
PropertyReferenceValue.prototype.evaluate = function(valueProvider) {};

/**
 * Sets the value indicated by the path
 */
PropertyReferenceValue.prototype.set = function(value) {};

/**
 * @export
 */
PropertyReferenceValue.prototype.addChangeHandler=function(cmp, key, method, rebind) {};


/**
 * @export
 */
PropertyReferenceValue.prototype.removeChangeHandler=function(cmp, key){};

/**
 * Returns the value in the format "v.expression".
 */
PropertyReferenceValue.prototype.getExpression = function() {};

PropertyReferenceValue.prototype.getIsGlobal = function() {};

PropertyReferenceValue.prototype.getReference = function(path) {};

PropertyReferenceValue.prototype.equals = function (target){};

/**
 * Sets the isDirty flag to false.
 * @export
 */
PropertyReferenceValue.prototype.isDirty = function() {};

/**
 * Destroys the path.
 * @export
 */
PropertyReferenceValue.prototype.destroy = function() {};

/**
 * Returns "PropertyReferenceValue" as String.
 * @export
 */
PropertyReferenceValue.prototype.toString = function() {};

/**
 * When serializing say an Action, we don't want to serialize the reference elements, but the value under the covers.
 */
PropertyReferenceValue.prototype.toJSON = function() {};

Aura.Value.PropertyReferenceValue = PropertyReferenceValue;
