/*
 * Copyright (c) 2016 Scott Wells, All rights reserved
 */

// Stub interfaces for the JavaScript standard library taken from:
// http://www.w3schools.com/jsref/default.asp

// Global variables
var Infinity;
var NaN;
var undefined;

// Global functions
function decodeURI(encodedUri) {}
function decodeURIComponent(encodedUriComponent) {}
function encodeURI(uri) {}
function encodeURIComponent(uriComponent) {}
function escape(str) {}
function eval(expr) {}
function isFinite(val) {}
function isNaN(val) {}
function Number(val) {}
function parseFloat(str) {}
function parseInt(str) {}
function String(val) {}
function unescape(str) {}

/**
@type {String}
@const
*/
String = {};
String.prototype = {
    // Properties
    constructor: function() {},
    length: 0,

    // Methods
    charAt: function(pos) {},
    charCodeAt: function(pos) {},
    concat: function(strs) {},
    endsWith: function(str) {},
    fromCharCode: function(charCode) {},
    includes: function(str) {},
    indexOf: function(str) {},
    lastIndexOf: function(str) {},
    localeCompare: function(str) {},
    match: function(pattern) {},
    repeat: function(count) {},
    replace: function(searchValue, newValue) {},
    search: function(searchValue) {},
    slice: function(start, end) {},
    split: function(separator, limit) {},
    startsWith: function(str) {},
    substr: function(start, length) {},
    substring: function(start, end) {},
    toLocaleLowerCase: function() {},
    toLocaleUpperCase: function() {},
    toLowerCase: function() {},
    toString: function() {},
    toUpperCase: function() {},
    trim: function() {},
    valueOf: function() {}
};

/**
@type {Number}
@const
*/
Number = {};
Number.prototype = {
    // Properties
    constructor: function() {},
    MAX_VALUE: 0,
    MIN_VALUE: 0,
    NEGATIVE_INFINITY: 0,
    NaN: 0,
    POSITIVE_INFINITY: 0,

    // Methods
    isFinite: function(val) {},
    isInteger: function(val) {},
    isNaN: function(val) {},
    isSafeInteger: function(val) {},
    toExponential: function(x) {},
    toFixed: function(x) {},
    toPrecision: function(x) {},
    toString: function() {},
    valueOf: function(str) {}
};

/**
@type {Math}
@const
*/
Math = {};
Math.prototype = {
    // Properties
    E: 0,
    LN2: 0,
    LN10: 0,
    LOG2E: 0,
    LOG10E: 0,
    PI: 0,
    SQRT1_2: 0,
    SQRT2: 0,

    // Methods
    abs: function(x) {},
    acos: function(x) {},
    asin: function(x) {},
    atan: function(x) {},
    atan2: function(x) {},
    ceil: function(x) {},
    cos: function(x) {},
    exp: function(x) {},
    floor: function(x) {},
    log: function(x) {},
    max: function(vals) {},
    min: function(vals) {},
    pow: function(x, y) {},
    random: function() {},
    sin: function(x) {},
    sqrt: function(x) {},
    tan: function(x) {}
};

/**
@type {Date}
@const
*/
Date = {};
Date.prototype = {
    // Properties
    constructor: function() {},

    // Methods
    getDate: function() {},
    getDay: function() {},
    getFullYear: function() {},
    getHours: function() {},
    getMilliseconds: function() {},
    getMinutes: function() {},
    getMonth: function() {},
    getSeconds: function() {},
    getTime: function() {},
    getTimezoneOffset: function() {},
    getUTCDate: function() {},
    getUTCDay: function() {},
    getUTCFullYear: function() {},
    getUTCHours: function() {},
    getUTCMilliseconds: function() {},
    getUTCMinutes: function() {},
    getUTCMonth: function() {},
    getUTCSeconds: function() {},
    getYear: function(x, y) {},
    now: function() {},
    parse: function(str) {},
    setDate: function(date) {},
    setDay: function(day) {},
    setFullYear: function(fullYear) {},
    setHours: function(hours) {},
    setMilliseconds: function(millis) {},
    setMinutes: function(minutes) {},
    setMonth: function(month) {},
    setSeconds: function(seconds) {},
    setTime: function(time) {},
    setTimezoneOffset: function(offset) {},
    setUTCDate: function(utcDate) {},
    setUTCDay: function(utcDay) {},
    setUTCFullYear: function(utcFullYear) {},
    setUTCHours: function(utcHours) {},
    setUTCMilliseconds: function(utcMillis) {},
    setUTCMinutes: function(utcMinutes) {},
    setUTCMonth: function(utcMonth) {},
    setUTCSeconds: function(utcSeconds) {},
    setYear: function(year) {},
    toDateString: function() {},
    toGMTString: function() {},
    toISOString: function() {},
    toJSONString: function() {},
    toLocaleDateString: function() {},
    toLocaleTimeString: function() {},
    toLocaleString: function() {},
    toString: function() {},
    toTimeString: function() {},
    toUTCString: function() {},
    UTC: function() {},
    valueOf: function() {}
};

/**
@type {Array}
@const
*/
Array = {};
Array.prototype = {
    // Properties
    constructor: function() {},
    length: 0,

    // Methods
    concat: function(arrays) {},
    copyWithin: function(target, start, end) {},
    every: function(visitorFunction, thisValue) {},
    fill: function(value, start, end) {},
    filter: function(visitorFunction, thisValue) {},
    find: function(visitorFunction, thisValue) {},
    findIndex: function(visitorFunction, thisValue) {},
    forEach: function(visitorFunction, thisValue) {},
    indexOf: function(item, start) {},
    isArray: function(obj) {},
    join: function(separator) {},
    lastIndexOf: function(item, start) {},
    map: function(visitorFunction, thisValue) {},
    pop: function() {},
    push: function(values) {},
    reduce: function(visitorFunction, initialValue) {},
    reduceRight: function(visitorFunction, initialValue) {},
    reverse: function() {},
    shift: function(x, y) {},
    slice: function(start, end) {},
    some: function(visitorFunction, thisValue) {},
    sort: function(compareFunction) {},
    splice: function(index, howMany, items) {},
    toString: function() {},
    unshift: function(items) {},
    valueOf: function() {}
};

/**
@type {Boolean}
@const
*/
Boolean = {};
Boolean.prototype = {
    // Properties
    constructor: function() {},

    // Methods
    toString: function() {},
    valueOf: function() {}
};

/**
@type {RegExp}
@const
*/
RegExp = {};
RegExp.prototype = {
    // Properties
    constructor: function() {},
    global: 0,
    ignoreCase: 0,
    lastIndex: 0,
    multiline: 0,
    source: 0,

    // Methods
    compile: function(regexp, modifier) {},
    exec: function(string) {},
    test: function(string) {},
    toString: function() {}
};
